#!/usr/bin/perl
##################################################
# reader.cgi
#
# This script converts message from wwwboard format 
# to e_Board format. It assumes that your version
# of wwwboard was unmodified.
#
##################################################
# CONFIGURATION SECTION

# This is the complete path to the directory that 
# contains your wwwboard messages directory.

	$pathfrom = '/path/to/public_html/wwwboard';

# This is the complete path to the directory that 
# contains your e_Board messages directory.

	$pathto = '/path/to/public_html/eboard';

# Set this to 'no' to screen all html from wwwboard messages.

	$html = 'no';

# Set this to your message extensions, just like in wwwboard.cgi.

	$ext = '.html';


# END OF CONFIGURATION
###################################################

	print "Content-type: text/html\n\n";
	print "<html><head></head>\n";
	print "<BODY>\n";

	opendir(FILES, "$pathfrom/messages") or die print "Can't open messages Directory.";

	@messages = readdir (FILES);

	@messages = sort(@messages);
	
	@mlist = ();

	$pathto .='/messages';
	
	foreach $message (@messages){
		if (-d $message){next};
		if ($message !~ /\.htm/){next};

		open(OLD, "$pathfrom/messages/$message") or die print "Can't open $message.";
		@page=<OLD>;

		$message =~ s/$ext//;

		$replylist = '';

		for ($i=0;$i<=$#page;$i++){
			if ($page[$i] =~ /(<title>)(.+)(<\/title>)/){
				$subject = $2;
			}
			if ($page[$i] =~ /^Posted by/){
				if ($page[$i] =~ /(^Posted by <a href=\"mailto:)(.+)(\">)(.+)(<\/a> on)(.+)(:<p>)/){
					$email = $2;
					$name = $4;
					$date = $6;
				}elsif ($page[$i] =~ /(^Posted by )(.+)( on )(.+)(:<p>)/){
					$email = '';
					$name = $2;
					$date = $4;
				}
				$i++;
				if ($page[$i] =~ /(In Reply to: <a href=\")(\d+)(\.html\">)(.+)(<\/a> posted by )(.+)( on )(.+)(:)/){
					$pfilename = $2;
					$psubject = $4;
					$pname = $6;
					$pdate = $8;
					$i ++;
				}else{
					unshift (@mlist,"$message\n");
					$pfilename = '';
					$psubject = '';
					$pname = '';
					$pdate = '';
				}
				if ($page[$i] =~ /(^<center><img src=\")(.+)(\">)/){
					$imageurl = $2;
					$i ++;
				}else{
					$imageurl = '';
				}
				$body = $page[$i];
############custom filters for wwwboard on wipd.com
				$body =~ s/<center><table width=75% align=center><tr><td>//;
				$body =~ s/<\/td><\/tr><\/table><\/center>//;

				chomp($body);
				$body =~ s/<br>/*br*/g;
				$body =~ s/<p>/*p*/g;
				if($html eq 'no'){
					$body =~ s/<.+?>//g;
				}
			}
			if ($page[$i] =~ /(^<ul><li><a href=\")(.+)(\">)(.+)(<\/a>)/){
				$url = $2;
				$urlname = $4;
			}else{
				$url = '';
				$urlname = '';
			}
			if ($page[$i] =~ /(^<!--top: )(\d+)(-->)/){
				$reply = $2;
				if ($replylist eq ''){
					$replylist = $reply;
				}else{
					$replylist .= ", $reply";
				}
				while ($page[$i] !~ /<!--end: $reply-->/){$i ++};
			}
		}

		print "$message<br>\n";

		open (NEW, ">$pathto/$message\.txt");
		print NEW "$replylist\n";
		print NEW "$subject\n";
		print NEW "$name\n";
		print NEW "$email\n";
		print NEW "$date\n";
		print NEW "$body\n";
		print NEW "$psubject\n";
		print NEW "$pname\n";
		print NEW "$pfilename\n";
		print NEW "$pdate\n";
		print NEW "$url\n";
		print NEW "$urlname\n";
		print NEW "$imageurl\n";
		close (NEW);
	}

##########################################
# generate list

$level = 0;
chomp(@mlist);

for($j=0;$j<=$#mlist;$j++){
	open(REPLY, "$pathto/$mlist[$j].txt");
	@data = <REPLY>;
	close(REPLY);
	chomp(@data);
	$mlist[$j] = "$level\t$mlist[$j]\t$data[1]\t$data[2]\t$data[4]\n";
}

for($j=0;$j<=$#mlist;$j++){
	@temp = split(/\t/,$mlist[$j]);
	$level = $temp[0];
	open(REPLY, "$pathto/$temp[1].txt");
	@data = <REPLY>;
	close(REPLY);
	chomp(@data);
	$replies = $data[0];
	if($replies ne ''){
		$level++;
		@replies = split (/\, /, $replies);
		for ($i=0;$i<=$#replies;$i++){
			open(REPLY, "$pathto/$replies[$i].txt");
			@data = <REPLY>;
			close(REPLY);
			chomp(@data);
			$replies[$i] = "$level\t$replies[$i]\t$data[1]\t$data[2]\t$data[4]\n";
		}
		splice(@mlist, $j+1, 0, @replies);
	}
}

open (MLIST, ">$pathto/mlist.txt");
print MLIST @mlist;
close(MLIST);
print "</body></html>\n";

open (COUNTER, "$pathfrom/data.txt");
$counter = <COUNTER>;
close(COUNTER);

open (COUNTER, ">$pathto/counter.txt");
print COUNTER $counter;
close(COUNTER);

exit;
